"""add membership, progress and modify user and add video

Revision ID: ad8a076d04a6
Revises: 208dd144a013
Create Date: 2023-02-19 18:29:18.179836

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'ad8a076d04a6'
down_revision = '208dd144a013'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column('user', 'membership_status',
               existing_type=sa.VARCHAR(length=20),
               type_=sa.String(length=10),
               existing_nullable=True)
    op.add_column('video', sa.Column('stored_file_name', sa.String(), nullable=False))
    op.alter_column('video', 'title',
               existing_type=sa.VARCHAR(),
               nullable=False)
    op.alter_column('video', 'progress_state',
               existing_type=sa.VARCHAR(length=20),
               type_=sa.String(length=10),
               existing_nullable=True)
    op.create_unique_constraint(None, 'video', ['stored_file_name'])
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, 'video', type_='unique')
    op.alter_column('video', 'progress_state',
               existing_type=sa.String(length=10),
               type_=sa.VARCHAR(length=20),
               existing_nullable=True)
    op.alter_column('video', 'title',
               existing_type=sa.VARCHAR(),
               nullable=True)
    op.drop_column('video', 'stored_file_name')
    op.alter_column('user', 'membership_status',
               existing_type=sa.String(length=10),
               type_=sa.VARCHAR(length=20),
               existing_nullable=True)
    # ### end Alembic commands ###
